#
# spec file for package gcc-4.1 (Version 4.1.2)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# icecream 0
# neededforbuild  dejagnu doxygen expat expect glibc-devel-32bit graphviz libunwind libunwind-devel tcl texinfo

BuildRequires:  aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libselinux libstdc++ libxcrypt m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace syslogd sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils dejagnu doxygen expat expect gcc gdbm gettext glibc-64bit glibc-devel-64bit graphviz libtool perl rpm tcl

Name:           gcc-4.1
%define run_tests %(test -f %_sourcedir/RUN_TESTS && echo 1 || echo 0)
# Ada currently fails to build on a few platforms, enable it only
# on those that work
# Note that AdaCore only supports %ix86, x86_64 and ia64
%ifarch %ix86 x86_64 ia64 hppa ppc s390
%define build_ada 0
%else
# alpha ppc64 s390x
%define build_ada 0
%endif
# We don't want to build java on arm
%ifarch mips %arm
%define build_java 0
%else
%define build_java 0
%endif
%define build_fortran 0
%if %{build_ada}
%endif
%if %{build_java}
%endif
%if %{build_fortran}
%endif
%ifarch %ix86 x86_64 ia64
%endif
%if %{run_tests}
%endif
# Define this as 1 to get gcc packages for business products
%define gcc_for_opt 1
# Disable the use of icecream for this package.  It would generate
# too much parallelism when building state2 and stage3 and the runtime libs
# Just touch RUN_TESTS in the source dir to run the testsuite.
%if %{gcc_for_opt}
%define run_tests 0
%endif
# Define version number of libgcc_s
%ifarch hppa
%define libgcc_s 2
%else
%define libgcc_s 1
%endif
%ifarch ppc
# We support building the nof libraries, but don't want this in the
# regular rpms
%define build_nof 0
%else
%define build_nof 0
%endif
%ifarch ppc
# Beware, this does _not_ separate libgcj, as for that one multilibing
# is inactive for the time being
%define separate_bi64 1
%else
%define separate_bi64 0
%endif
%ifarch x86_64 ia64 s390x alpha ppc64
# 64-bit is primary build target
%define build_primary_64bit 1
%else
%define build_primary_64bit 0
%endif
%define biarch_libjava 0
# COMMON-BEGIN
%define biarch_targets x86_64 s390x ppc64 ppc
Url:            http://gcc.gnu.org/
License:        GPL
Version:        4.1.2
Release:        0.1
%define gcc_version %(echo %version | sed 's/_.*//')
%define snapshot_date %(echo %version | sed 's/[34]\.[0-4]\.[0-6]//' | sed 's/_/-/')
%if %{gcc_for_opt}
%define binsuffix -4.1
%define versionspecificlibs 1
%else
%define binsuffix %{nil}
%define versionspecificlibs 0
%endif
# versionspecificlibs means to put all .a,.so,.so.* into the version specific dir
# For SLES9 we want to put the .so.* files to /usr/lib/*, but not the others,
# hence this define.
%define globallibs 1
# COMMON-END
Requires:       binutils glibc-devel cpp-4.1 = %{version}-%{release} 
Provides:       c_compiler
# COMMON-BEGIN
Group:          Development/Languages/C and C++
Autoreqprov:    on
Summary:        The GNU C Compiler and Support Files
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Source:         gcc-%{gcc_version}%{snapshot_date}.tar.bz2
Source1:        change_spec
Patch1:         bug-reporting.patch
Patch2:         gcc-noalias-warn.diff
Patch5:         boehm-gc-strict-aliasing.patch
Patch7:         acats-timeout.patch
Patch10:        program-transform-name.diff
Patch12:        gcc4-ppc64-m32-m64-multilib-only.patch
Patch23:        libjava-no-multilib.diff
Patch24:        tls-no-direct.diff
Patch37:        pr20425.patch
Patch38:        large-gcc.diff
Patch43:        generic-cpu-model-1.patch
Patch44:        generic-cpu-model-2.patch
Patch45:        generic-cpu-model-3.patch
Patch47:        partial-flag-regstall.patch
Patch39:        tree_expr_nonzero.patch
Patch40:        vrp.patch
Patch46:        force_fit_type.patch
Patch48:        pr24879.patch
Patch82:        pr13212.patch
Patch93:        nvl161673.patch
Patch95:        pr26399.patch
Patch96:        nov189571.diff
Patch97:        nov189571-2.diff
Patch98:        nvl199137.patch
Patch100:       pr28755.patch
# A set of patches from the RH srpm
Patch51:        gcc41-ia64-stack-protector.patch
Patch55:        gcc41-java-slow_pthread_self.patch
Patch57:        gcc41-ppc32-retaddr.patch
Patch54:        gcc41-ldbl-default.patch
Patch50:        gcc41-ldbl-default-libstdc++.patch
Patch52:        note-gnu-stack.diff
Patch53:        gcc41-strncat-chk.patch
# general improvement patches
Patch60:        pr25626.patch
Patch61:        fortran-matmul.patch
Patch62:        gcc41-fortran-where-opt.patch
Patch63:        emmintr.patch
Patch64:        libstdcxx-bitset.patch
Patch65:        stack-protect-kernel.patch
Patch66:        pr26208.patch
Patch67:        dwarf3-constants.patch
Patch68:        dwarf3-unwind.patch
Patch69:        gcc41-mni.patch
Patch70:        pr27880.diff
Patch71:        pr29319.diff

%description
Language frontends other than C are split to different sub-packages,
namely gcc-ada, gcc-c++, gcc-fortran, gcc-java and gcc-objc.


%package locale
Summary:        gcc-locale
Group:          Development/Languages/C and C++
Requires:       gcc-4.1 = %{version}-%{release}
Autoreqprov:    on

%description locale

%package c++
Summary:        The GNU C++ Compiler
Group:          Development/Languages/C and C++
Autoreqprov:    on
Requires:       gcc-4.1 = %{version}-%{release}
Requires:       libstdc++-4.1 = %{version}-%{release}
Requires:       libstdc++-devel-4.1 = %{version}-%{release}
Provides:       c++_compiler

%description c++
This package contains the GNU compiler for C++.


%package -n libstdc++-devel-4.1
Summary:        Include Files and Libraries mandatory for Development
Group:          System/Libraries
Autoreqprov:    on
Requires:       libstdc++-4.1 = %{version}-%{release}
Requires:       gcc-4.1
Requires:       glibc-devel
%ifarch ia64
Requires:       libunwind-devel
%endif

%description -n libstdc++-devel-4.1
This package contains all the headers and libraries of the standard C++
library. It is needed for compiling C++ code.

The source code is in the package gcc.


%package -n libstdc++-devel-4.1-64bit
Summary:        Include Files and Libraries mandatory for Development (64 bit)
Group:          System/Libraries
Autoreqprov:    on
Requires:       libstdc++-4.1-64bit = %{version}-%{release}
Requires:       gcc-4.1

%description -n libstdc++-devel-4.1-64bit
This package contains the 64 bit variant for the C++ standard
library. It is needed for compiling 64 bit C++ code.

The source code is in the package gcc.


%package -n libgcc-4.1
Summary:        C compiler runtime library
Group:          System/Base
Autoreqprov:    on
%if %{globallibs}
Provides:       libgcc
Obsoletes:      libgcc
%endif

%description -n libgcc-4.1
Libgcc is needed for dynamically linked C programs.


%package -n libgcc-4.1-64bit
Summary:        C compiler runtime library
Group:          System/Base
Autoreqprov:    on
%if %{globallibs}
Provides:       libgcc-64bit
Obsoletes:      libgcc-64bit
%endif

%description -n libgcc-4.1-64bit
Libgcc-64bit is needed for dynamically linked 64bit C programs.


%package -n libstdc++-4.1
Summary:        The standard C++ shared library
Group:          System/Libraries
Autoreqprov:    on

%description -n libstdc++-4.1
The standard C++ library, needed for dynamically linked C++ programs.

Authors:
--------
    Paolo Carlini <pcarlini@suse.de>
    Gabriel Dos Reis <gdr@integrable-solutions.net>
    Ulrich Drepper <drepper@redhat.com>
    Phil Edwards <pme@gcc.gnu.org>
    Benjamin Kosnik <bkoz@redhat.com>
    Loren J. Rittle <ljrittle@acm.org>
    et.al.

%package -n libstdc++-4.1-64bit
Summary:        The standard C++ shared library
Group:          System/Libraries
Autoreqprov:    on

%description -n libstdc++-4.1-64bit
The standard C++ library, needed for dynamically linked 64 bit C++ programs.


%package info
Summary:        GNU Info-Pages for GCC
Group:          Development/Languages/C and C++
Autoreqprov:    on
%if %{gcc_for_opt}
Conflicts:      gcc-info
%endif

%description info
GNU info-pages for GCC.


%package objc
Summary:        GNU Objective C Compiler
Group:          Development/Languages/Other
Autoreqprov:    on
Requires:       gcc-4.1 = %{version}-%{release}
Requires:       libobjc-4.1 = %{version}-%{release}

%description objc
This package contains the GNU Objective C compiler. Objective C is an
object oriented language, created by Next Inc. and used in their
Nextstep OS. The source code is available in the gcc package.


%package -n libobjc-4.1
Summary:        Library for the GNU Objective C Compiler
Group:          Development/Libraries/Other

%description -n libobjc-4.1
The library for the GNU Objective C compiler.


%package objc-64bit
Summary:        GNU Objective C Compiler
Group:          Development/Languages/Other
Autoreqprov:    on
Requires:       gcc-4.1 = %{version}-%{release}
Requires:       libobjc-4.1-64bit = %{version}-%{release}

%description objc-64bit
This package contains the GNU Objective C compiler. Objective C is an
object oriented language, created by Next Inc. and used in their
Nextstep OS. The source code is available in the gcc package.


%package -n libobjc-4.1-64bit
Summary:        Library for the GNU Objective C Compiler
Group:          Development/Libraries/Other

%description -n libobjc-4.1-64bit
The library for the GNU Objective C compiler.


%package -n cpp-4.1
Summary:        The GCC Preprocessor
Group:          Development/Languages/C and C++

%description -n cpp-4.1
This Package contains just the preprocessor that is used by the X11
packages.


%package java
Summary:        The GNU Java Compiler
Group:          Development/Languages/Java
Autoreqprov:    on
Requires:       gcc-4.1 = %{version}-%{release}
Requires:       libgcj-4.1 = %{version}-%{release}
Requires:       libgcj-devel-4.1 = %{version}-%{release}

%description java
The Java compiler from the GCC-tools-suite.


%package -n libgcj-4.1
Summary:        Java Runtime Library for gcc
Group:          System/Libraries
Autoreqprov:    on

%description -n libgcj-4.1
This library is needed if you want to use the GNU Java compiler, gcj.
Source code for this package is in gcc.


%package -n libgcj-devel-4.1
Summary:        Include Files and Libraries mandatory for Development.
Group:          Development/Libraries/Java
Autoreqprov:    on
Requires:       libstdc++-devel-4.1 = %{version}-%{release}
Requires:       libgcj-4.1 = %{version}-%{release}
Requires:       gtk2-devel
Requires:       libart_lgpl-devel
Requires:       glibc-devel
Requires:       zlib-devel
%ifarch ia64
Requires:       libunwind-devel
%endif

%description -n libgcj-devel-4.1
This package contains all necessary include files and libraries needed
to develop applications that require these.


%package ada
Requires:       gcc-4.1 = %{version}-%{release}
Requires:       libada-4.1 = %{version}-%{release}
Summary:        GNU Ada95 Compiler Based on GCC (GNAT)
Group:          Development/Languages/Other
Autoreqprov:    on
Provides:       gnat-4.1
Obsoletes:      gnat-4.1

%description ada
This package contains an Ada95 compiler and associated development
tools based on the GNU GCC technology. Ada95 is the object oriented
successor of the Ada83 language. To build this package from source you
must have installed a binary version to bootstrap the compiler.


%package -n libada-4.1
Summary:        GNU Ada Runtime Libraries
Group:          System/Libraries
Provides:       gnat-runtime-4.1
Obsoletes:      gnat-runtime-4.1

%description -n libada-4.1
This package contains the shared libraries required to run programs
compiled with the GNU Ada compiler (GNAT) if they are compiled to use
shared libraries. It also contains the shared libraries for the
Implementation of the Ada Semantic Interface Specification (ASIS), the
implementation of Distributed Systems Programming (GLADE) and the Posix
1003.5 Binding (Florist).


%package fortran
Summary:        The GNU Fortran Compiler and Support Files
Group:          Development/Languages/Fortran
Autoreqprov:    on
Requires:       gcc-4.1 = %{version}-%{release}

%description fortran
This is the Fortran compiler of the GNU Compiler Collection (GCC).


%package fortran-64bit
Summary:        The GNU Fortran Compiler and Support Files (64bit)
Group:          Development/Languages/Fortran
Autoreqprov:    on
Requires:       gcc-4.1 = %{version}-%{release}
Requires:       glibc-devel-64bit

%description fortran-64bit
This is the Fortran compiler of the GNU Compiler Collection (GCC) for 64bit.


%package mudflap
Summary:        The Mudflap Extension to GCC
Group:          Development/Languages/C and C++
Autoreqprov:    on
Requires:       glibc-devel

%description mudflap
This is the Mudflap Extension of the GNU Compiler Collection (GCC).


%package mudflap-64bit
Summary:        The Mudflap Extension to GCC (64bit)
Group:          Development/Languages/C and C++
Autoreqprov:    on
Requires:       glibc-devel-64bit

%description mudflap-64bit
This is the Mudflap Extension of the GNU Compiler Collection (GCC) for 64bit.





%if "%{name}" != "gcc-4.1"
%define TARGET_ARCH %(echo %{name}|sed -e "s/cross-\\(.*\\)-gcc-icecream-backend/\\1/;s/-/_/g")
%else
%define TARGET_ARCH %{_target_cpu}
%endif
%define biarch %(case " %{biarch_targets} " in (*" %{TARGET_ARCH} "*) echo 1;; (*) echo 0;; esac)
%define BUILD_TARGET %(echo %{TARGET_ARCH}|sed -e "s/i.86/i586/;s/ppc/powerpc/")
%ifarch ppc
%define GCCDIST powerpc64-suse-linux
%else
%define GCCDIST %(echo %{_target_cpu}|sed -e "s/i.86/i586/" -e "s/ppc/powerpc/")-suse-linux
%endif
%define libsubdir %{_libdir}/gcc/%{GCCDIST}/%{gcc_version}
%define gxxinclude %{_prefix}/include/c++/%{gcc_version}
%if %{versionspecificlibs}
%define mainlibdir %{libsubdir}
%define mainlibdirbi32 %{libsubdir}/32
%define mainlibdirbi64 %{libsubdir}/64
%ifarch ppc
%define noflibdir %{libsubdir}/nof
%define mainlibdirbi32 %{libsubdir}
%define mainlibdirbi64 %{libsubdir}/64
%endif
%ifarch ppc64
%define noflibdir %{libsubdir}/32/nof
%endif
%else
%define mainlibdir %{_libdir}
%define mainlibdirbi32 %{_prefix}/lib
%define mainlibdirbi64 %{_prefix}/lib64
%define noflibdir %{_prefix}/lib/nof
%endif
%prep
%setup -q -n gcc-%{gcc_version}%{snapshot_date}
%patch1
%patch2
%patch5
%patch7
%patch10
%if !%{build_nof}
%patch12
%endif
%patch23
%patch24
%patch37
%patch38
%patch43
%patch44
%patch45
%patch47
%patch39
%patch40
%patch46
%patch48
%patch82
%patch93
%patch95
%patch96
%patch97
%patch98 -p1
%patch100
%patch51
%patch55
%patch57
%patch54
%patch50
%patch52
%patch53
cd libstdc++-v3
%patch60
%patch64
cd ..
%patch61
%patch62 -p1
%patch63
%patch65
%patch66
%patch67
%patch68
#%patch69
%patch70
%patch71

%build
# Avoid conflict with commercial libjawt.so
sed -i -e 's/libjawt/libgcjawt/g' libjava/Makefile.{am,in}
# Avoid rebuilding of generated files
contrib/gcc_update --touch
rm -rf obj-%{GCCDIST}
mkdir obj-%{GCCDIST}
cd obj-%{GCCDIST}
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -U_FORTIFY_SOURCE"
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g' -e 's/-Wmissing-format-attribute//g'`
%ifarch %ix86
# -mcpu is superceded by -mtune but -mtune is not supported by
# our bootstrap compiler.  -mcpu gives a warning that stops
# the build process, so remove it for now.
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-mcpu=i.86//g'`
%endif
%ifarch s390 s390x
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fsigned-char//g'`
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-O1/-O2/g'`
%endif
%if "%{name}" == "cross-avr-gcc"
# Kill all -march/tune/cpu because that screws building the target libs
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-m\(arch\|tune\|cpu\)=[^ ]*//g'`
%endif
# Replace 2 spaces by one finally
RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/  / /g'`
languages=c,c++,objc
%if %{build_fortran}
languages=$languages,fortran
%endif
%if %{build_java}
languages=$languages,java
%endif
%if %{build_ada}
languages=$languages,ada
%endif
# override for cross-avr-gcc
%if "%{name}" == "cross-avr-gcc"
languages=c,c++
%endif
J=%{?jobs:%jobs}
if test -z "$J"; then
  J=$(getconf _NPROCESSORS_CONF)
  JL=$(($J * 2))
else
  test 1 -gt "$J" && J=1
  JL=$(($(getconf _NPROCESSORS_CONF)*2))
fi
if test "$J" == "0"; then
  J=1
fi
if test "$JL" == "0"; then
  JL=1
fi
PARALLEL="-j$J -l$JL"
# we don't want some miscompiles in the testsuite, or some fault in
# the compiler to kill the machine.  Hence we limit the amount of memory
# by the physical RAM plus half of swap
MEM=$(free -m | awk '/^Mem:/ {print $2}')
SWAP=$(free -m | awk '/^Swap:/ {print $2}')
#ulimit -v $(((MEM + SWAP/2)*1024))
# In general we want to ship release checking enabled compilers
# and run BETA with checking enabled.
#ENABLE_CHECKING=--enable-checking
ENABLE_CHECKING="--enable-checking=release"
%if "%{name}" != "gcc-4.1"
export PATH=/opt/cross/bin:$PATH
%endif
# Work around tail/head -1 changes
export _POSIX2_VERSION=199209
# configure tries to parse include/features.h to detect
# if glibc supports SSP.  When cross compiling we would need
# to install a cross glibc, which we don't, or make the whole
# thing point to the native glibc, which is in /, hence the
# --with-sysroot=/
CFLAGS="$RPM_OPT_FLAGS" CXXFLAGS="$RPM_OPT_FLAGS" XCFLAGS="$RPM_OPT_FLAGS" \
TCFLAGS="$RPM_OPT_FLAGS" GCJFLAGS="$RPM_OPT_FLAGS" \
../configure \
%if "%{name}" != "cross-avr-gcc"
	--enable-threads=posix \
%endif
	--prefix=%{_prefix} --with-local-prefix=/usr/local \
	--infodir=%{_infodir} --mandir=%{_mandir} \
	--libdir=%{_libdir} --libexecdir=%{_libdir} \
	--enable-languages=$languages $ENABLE_CHECKING \
	--with-gxx-include-dir=/usr/include/c++/%{gcc_version} \
	--enable-ssp --disable-libssp \
%if !%{build_java}
        --disable-libgcj \
%else
        --enable-java-awt=gtk --enable-gtk-cairo \
%if !%{biarch_libjava}
        --disable-libjava-multilib \
%endif
%endif
	--with-slibdir=/%{_lib} --with-system-zlib \
	--enable-shared --enable-__cxa_atexit \
	--enable-libstdcxx-allocator=new \
%if "%{name}" != "gcc-4.1"
%if "%{name}" == "cross-avr-gcc"
	--target=avr \
%else
%if "%{BUILD_TARGET}" == "powerpc"
	--target=powerpc64-linux \
	--with-as=/opt/cross/powerpc-linux/bin/as \
	--with-ld=/opt/cross/powerpc-linux/bin/ld \
%else
	--target=%{BUILD_TARGET}-linux \
%endif
%endif
	--disable-nls --disable-shared \
%if "%{name}" != "cross-avr-gcc"
	--with-sysroot=/ \
%endif
%else
%if %{gcc_for_opt}
	--program-suffix=%{binsuffix} \
%endif
%if %{versionspecificlibs}
	 --enable-version-specific-runtime-libs \
%endif
%ifarch ia64
	--with-system-libunwind \
%else
	--without-system-libunwind \
%endif
%endif
%if "%{BUILD_TARGET}" == "powerpc"
	--with-cpu=default32 \
	--with-long-double-128 \
%endif
%if "%{BUILD_TARGET}" == "powerpc64"
	--with-long-double-128 \
%endif
%if "%{BUILD_TARGET}" == "i586"
	--with-cpu=generic \
%endif
%if "%{BUILD_TARGET}" == "x86_64"
	--with-cpu=generic \
%endif
%if "%{BUILD_TARGET}" == "s390"
        --with-tune=z9-109 --with-arch=z900 \
	--with-long-double-128 \
%endif
%if "%{BUILD_TARGET}" == "s390x"
        --with-tune=z9-109 --with-arch=z900 \
	--with-long-double-128 \
%endif
	--host=%{GCCDIST}
# COMMON-END
# Only run profiled bootstrap on archs where it works
#%ifarch %ix86 x86_64 ppc ppc64 ia64
#make profiledbootstrap BOOT_CFLAGS="$RPM_OPT_FLAGS" $PARALLEL
#%else
make bootstrap-lean BOOT_CFLAGS="$RPM_OPT_FLAGS" $PARALLEL
#%endif
make -C gcc proto
make info
%if %{run_tests}
echo "Run testsuite"
make -k check $PARALLEL || true
(make -C %{GCCDIST}/libstdc++-v3 check-abi || true)
%endif

%install
# get Check to pick up man/info pages under /opt
%if %{gcc_for_opt}
manpath=%{_mandir}:%{_infodir}
export manpath
%endif
rm -rf $RPM_BUILD_ROOT
cd obj-%{GCCDIST}
# Work around tail/head -1 changes
export _POSIX2_VERSION=199209
export LIBRARY_PATH=$RPM_BUILD_ROOT%{libsubdir}:$RPM_BUILD_ROOT%{mainlibdirbi32}:$RPM_BUILD_ROOT%{mainlibdirbi64}
make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_libdir}
# Fix c++config.h for multilibs
cxxconfig="`find %{GCCDIST}/libstdc++-v3/include -name c++config.h`"
for i in `find %{GCCDIST}/[36]*/libstdc++-v3/include -name c++config.h 2>/dev/null`; do
  if ! diff -up $cxxconfig $i; then
    file_32=x
    file_64=x
    case $i in
      %{GCCDIST}/32/*)
        file_32=$i
        file_64=$cxxconfig
	;;
      %{GCCDIST}/64/*)
        file_32=$cxxconfig
	file_64=$i
	;;
    esac
    if ! ( test -f "$file_32" && test -f "$file_64" ); then
      echo "Urgs?"
      exit 1
    fi
    
    cat > $RPM_BUILD_ROOT%{_prefix}/include/c++/%{gcc_version}/%{GCCDIST}/bits/c++config.h <<EOF
#ifndef _CPP_CPPCONFIG_WRAPPER
#define _CPP_CPPCONFIG_WRAPPER 1
#include <bits/wordsize.h>
#if __WORDSIZE == 32
`cat $file_32`
#else
`cat $file_64`
#endif
#endif
EOF
    break
  fi
done
# Move libgcc_s around
%if %{versionspecificlibs}
%if %{globallibs}
mv $RPM_BUILD_ROOT/%{_lib}/libgcc_s*.so $RPM_BUILD_ROOT%{mainlibdir}
ln -sf /%{_lib}/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{mainlibdir}/libgcc_s.so
%else
mv $RPM_BUILD_ROOT/%{_lib}/libgcc_s*.so* $RPM_BUILD_ROOT%{mainlibdir}
%endif
%if %{biarch}
%if %{build_primary_64bit}
%if %{globallibs}
mv $RPM_BUILD_ROOT/lib/libgcc_s*.so $RPM_BUILD_ROOT%{mainlibdirbi32}
ln -sf /lib/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{mainlibdirbi32}/libgcc_s.so
ln -sf /lib/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{mainlibdirbi32}/libgcc_s_32.so
%else
mv $RPM_BUILD_ROOT/lib/libgcc_s*.so* $RPM_BUILD_ROOT%{mainlibdirbi32}
ln -sf %{mainlibdirbi32}/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{mainlibdirbi32}/libgcc_s.so
ln -sf %{mainlibdirbi32}/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{mainlibdirbi32}/libgcc_s_32.so
%endif
%else
%if %{globallibs}
mv $RPM_BUILD_ROOT/lib64/libgcc_s.so $RPM_BUILD_ROOT%{mainlibdirbi64}
ln -sf /lib64/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{mainlibdirbi64}/libgcc_s_64.so
%else
mv $RPM_BUILD_ROOT/lib64/libgcc_s.so* $RPM_BUILD_ROOT%{mainlibdirbi64}
ln -sf %{mainlibdirbi32}/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{mainlibdirbi64}/libgcc_s_64.so
%endif
%endif
%if %{build_nof}
%if %{globallibs}
mv $RPM_BUILD_ROOT/%{_lib}/nof/libgcc_s*.so $RPM_BUILD_ROOT%{noflibdir}
%else
mv $RPM_BUILD_ROOT/%{_lib}/nof/libgcc_s*.so* $RPM_BUILD_ROOT%{noflibdir}
%endif
%endif
%endif
%else #!versionspecificlibs
rm -f $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so
ln -sf /%{_lib}/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{_libdir}/libgcc_s.so
chmod a+x $RPM_BUILD_ROOT/%{_lib}/libgcc_s.so.%{libgcc_s}
%if %{biarch}
%if %{build_primary_64bit}
rm -f $RPM_BUILD_ROOT/lib/libgcc_s.so
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib
ln -sf /lib/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{_prefix}/lib/libgcc_s.so
ln -sf /lib/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{_prefix}/lib/libgcc_s_32.so
chmod a+x $RPM_BUILD_ROOT/lib/libgcc_s.so.%{libgcc_s}
%else
# 32-bit biarch systems
rm -f $RPM_BUILD_ROOT/lib64/libgcc_s.so
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib64
ln -sf /lib64/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{_prefix}/lib64/libgcc_s.so
ln -sf /lib64/libgcc_s.so.%{libgcc_s} $RPM_BUILD_ROOT%{_prefix}/lib64/libgcc_s_64.so
chmod a+x $RPM_BUILD_ROOT/lib64/libgcc_s.so.%{libgcc_s}
%endif
%endif
%if %{build_nof}
# Note: ppc64 has only 32-bit nof libraries
# XXX rm -f $RPM_BUILD_ROOT/lib/libgcc_s_nof.so
#ln -sf /lib/libgcc_s_nof.so.%{libgcc_s} $RPM_BUILD_ROOT%{_prefix}/lib/libgcc_s_nof.so
%endif
%endif
%if %{build_ada}
mv $RPM_BUILD_ROOT%{libsubdir}/adalib/lib*-*.so $RPM_BUILD_ROOT%{_libdir}
ln -sf %{_libdir}/$(cd $RPM_BUILD_ROOT%{_libdir} && echo libgnarl-*.so) $RPM_BUILD_ROOT%{libsubdir}/adalib/libgnarl.so
ln -sf %{_libdir}/$(cd $RPM_BUILD_ROOT%{_libdir} && echo libgnat-*.so) $RPM_BUILD_ROOT%{libsubdir}/adalib/libgnat.so
chmod a+x $RPM_BUILD_ROOT%{_libdir}/libgna*-*.so
%endif
ln -sf gcc%{binsuffix} $RPM_BUILD_ROOT%{_prefix}/bin/cc%{binsuffix}
ln -sf g++%{binsuffix}  $RPM_BUILD_ROOT%{_prefix}/bin/c++%{binsuffix}
mkdir -p $RPM_BUILD_ROOT/lib
%if !%{gcc_for_opt}
cat <<\EOF > $RPM_BUILD_ROOT/lib/cpp
#!/bin/sh
# Traditionally, /lib/cpp only knew about C
exec %{_prefix}/bin/cpp -xc "$@"
EOF
chmod 755 $RPM_BUILD_ROOT/lib/cpp
%endif
%if %{biarch}
%if %{build_primary_64bit}
# move around some libs that end in wrong paths
pushd .
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib
(cd $RPM_BUILD_ROOT%{_libdir}/32; tar cf - *) | (cd $RPM_BUILD_ROOT%{_prefix}/lib ; tar xf -)
rm -rf $RPM_BUILD_ROOT%{_libdir}/32
ln -s %{_prefix}/lib $RPM_BUILD_ROOT%{_libdir}/32
rm -rf $RPM_BUILD_ROOT/%{_lib}/32
ln -s /lib $RPM_BUILD_ROOT/%{_lib}/32
popd
%else
# 32-bit biarch systems
# move around some libs that end in wrong paths
pushd .
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib64
cd $RPM_BUILD_ROOT%{_libdir}/64
for f in *; do
  mv $RPM_BUILD_ROOT%{_libdir}/64/$f $RPM_BUILD_ROOT%{_prefix}/lib64
done
rm -rf $RPM_BUILD_ROOT%{_libdir}/64
ln -s %{_prefix}/lib $RPM_BUILD_ROOT%{_libdir}/64
popd
%endif
%endif
# If we have version specific libs, but we want the .so.* files to be in the global
# directories, move them now
%if %{versionspecificlibs}
%if %{globallibs}
mv $RPM_BUILD_ROOT%{mainlibdir}/libstdc++.so.* $RPM_BUILD_ROOT%{_libdir}/
ln -sf /%{_libdir}/libstdc++.so.6 $RPM_BUILD_ROOT%{mainlibdir}/libstdc++.so
%if %{build_nof}
mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib/nof
mv $RPM_BUILD_ROOT%{noflibdir}/libstdc++.so.* $RPM_BUILD_ROOT%{_prefix}/lib/nof/
ln -sf /%{_prefix}/lib/nof/libstdc++.so.6 $RPM_BUILD_ROOT%{noflibdir}/libstdc++.so
%endif
%if %{biarch}
%if %{build_primary_64bit}
mv $RPM_BUILD_ROOT%{mainlibdirbi32}/libstdc++.so.* $RPM_BUILD_ROOT%{_prefix}/lib/
ln -sf /%{_prefix}/lib/libstdc++.so.6 $RPM_BUILD_ROOT%{mainlibdirbi32}/libstdc++.so
%else
mv $RPM_BUILD_ROOT%{mainlibdirbi64}/libstdc++.so.* $RPM_BUILD_ROOT%{_prefix}/lib64/
ln -sf /%{_prefix}/lib64/libstdc++.so.6 $RPM_BUILD_ROOT%{mainlibdirbi64}/libstdc++.so
%endif
%endif
%endif
%endif
# Remove some crap from the .la files:
for l in $RPM_BUILD_ROOT%{mainlibdir}/*.la \
%if %{versionspecificlibs}
%if %{biarch}
    $RPM_BUILD_ROOT%{mainlibdir}/*.la \
    $RPM_BUILD_ROOT%{mainlibdirbi32}/*.la \
%endif
%else
%if %{biarch}
%if %{build_primary_64bit}
    $RPM_BUILD_ROOT%{_prefix}/lib/*.la \
%else
    $RPM_BUILD_ROOT%{_prefix}/lib64/*.la \
%endif
%endif
%endif
    ; do
  echo "changing $l"
  sed -e '/^dependency_libs/s| -L/usr/src/packages/BUILD/[^ ]*||g' \
      -e '/^dependency_libs/s| -L/usr/%{GCCDIST}/bin||g' \
      -e '/^dependency_libs/s|-lm \(-lm \)*|-lm |' \
      -e '/^dependency_libs/s|-L[^ ]* ||g' \
%if %{biarch}
%if %{build_primary_64bit}
      -e '/^libdir/s|%{_libdir}/32|%{_prefix}/lib|' \
      -e '/^libdir/s|lib64/\.\./||' \
%else
      -e '/^libdir/s|%{_libdir}/64|%{_prefix}/lib64|' \
%endif
%endif
      < $l  > $l.new
  mv $l.new $l
done
%if %{gcc_for_opt}
%ifarch x86_64
perl  -pi -e "s|^(.*elf_i386.*)|\1 %{m32:-rpath=/opt/gcc33/lib} %{\!m32:-rpath=/opt/gcc33/lib64}|;"  $RPM_BUILD_ROOT%{_prefix}/lib64/gcc/x86_64-suse-linux/3.3/specs
%endif
%endif
%if %{run_tests} 
mkdir ../testresults
cp `find . -name "*.sum"` ../testresults/
cp `find . -name "*.log"  \! -name "config.log" |grep -v 'acats/tests' ` ../testresults/
%endif
# Find C++ and Java headers
find $RPM_BUILD_ROOT%{_prefix}/include/c++ \
  -regex ".*/\(org\|gcj\|gnu\|java\|javax\)" -prune \
  -o \( -type d -printf "%%%%dir " , \
        -printf "%{_prefix}/include/c++/%%P\n" \) > ../c++-headers
# Remove files that we do not need to clean up filelist
rm -f $RPM_BUILD_ROOT%{_prefix}/bin/%{GCCDIST}-*
rm -rf $RPM_BUILD_ROOT%{libsubdir}/install-tools
rm -rf $RPM_BUILD_ROOT%{libsubdir}/install-tools
rm -rf $RPM_BUILD_ROOT%{_libdir}/pkgconfig/libgcj.pc
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include/root
rm -f $RPM_BUILD_ROOT%{libsubdir}/include/curses.h
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include/asm-*
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include/linux
rm -f $RPM_BUILD_ROOT%{libsubdir}/include/ncurses.h
rm -f $RPM_BUILD_ROOT%{libsubdir}/include/stdio.h
rm -f $RPM_BUILD_ROOT%{libsubdir}/include/zutil.h
rm -f $RPM_BUILD_ROOT%{libsubdir}/include/X11
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include/bits
rm -f $RPM_BUILD_ROOT%{libsubdir}/include/obstack.h
rm -f $RPM_BUILD_ROOT%{libsubdir}/include/spe.h
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include/bits
rm -rf $RPM_BUILD_ROOT%{libsubdir}/include/sys
rm -f  $RPM_BUILD_ROOT%{_infodir}/dir
%if %{build_java}
# gcj -static doesn't work properly anyway, unless using --whole-archive
# let's save the space instead.
find $RPM_BUILD_ROOT -name libgcj.a -o -name lib-gnu-java-awt-peer-gtk.a \
                     -o -name libgjsmalsa.a \
                     -o -name libgij.a -o -name libgcjawt.a | xargs rm -f
find $RPM_BUILD_ROOT -name libgcj.spec | xargs \
  sed -i -e 's/lib: /&%%{static:%%eJava programs cannot be linked statically}/'
rm -f $RPM_BUILD_ROOT%{_prefix}/include/ffi*
rm -fr $RPM_BUILD_ROOT%{libsubdir}/include/libffi
rm -f $RPM_BUILD_ROOT%{_libdir}/libffi*
%if %{build_nof}
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/nof/libffi*
%endif
%if %{biarch}
%if %{build_primary_64bit}
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/libffi*
%else
rm -f $RPM_BUILD_ROOT%{_prefix}/lib64/libffi*
%endif
%endif
rm $RPM_BUILD_ROOT%{_mandir}/man1/jv-convert%{binsuffix}.1
%endif
rm $RPM_BUILD_ROOT%{_mandir}/man7/fsf-funding.7
rm $RPM_BUILD_ROOT%{_mandir}/man7/gfdl.7
rm $RPM_BUILD_ROOT%{_mandir}/man7/gpl.7
rm $RPM_BUILD_ROOT%{_libdir}/libiberty.a
%if %{build_nof}
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/nof/libiberty.a
%endif
%if %{biarch}
%if %{build_primary_64bit}
rm -f $RPM_BUILD_ROOT%{_prefix}/lib/libiberty.a
%else
rm -f $RPM_BUILD_ROOT%{_prefix}/lib64/libiberty.a
%endif
%endif
# Delete some files...
%if %{versionspecificlibs}
%if %{build_java}
rm $RPM_BUILD_ROOT%{_libdir}/logging.properties
rm $RPM_BUILD_ROOT%{_libdir}/security/classpath.security
rm $RPM_BUILD_ROOT%{_libdir}/security/libgcj.security
%endif
rm $RPM_BUILD_ROOT%{_infodir}/*.info*
rm $RPM_BUILD_ROOT%{_prefix}/share/locale/*/LC_MESSAGES/*.mo
%endif
# On SLES9 we don't yet have the 'rw' language in filesystem, and it doesn't
# contain any translations anyway
rm -rf $RPM_BUILD_ROOT%{_prefix}/share/locale/rw

%post info
%if !%{gcc_for_opt}
%install_info --info-dir=%{_infodir} %{_infodir}/cpp.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/cppinternals.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gcc.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gccint.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gccinstall.info.gz
%endif

%postun info
%if !%{gcc_for_opt}
%install_info_delete --info-dir=%{_infodir} %{_infodir}/cpp.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/cppinternals.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gcc.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gccint.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gccinstall.info.gz
%endif

%post java
%if !%{gcc_for_opt}
%install_info --info-dir=%{_infodir} %{_infodir}/gcj.info.gz
%endif

%postun java
%if !%{gcc_for_opt}
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gcj.info.gz
%endif

%post -n libgcj-4.1
%if !%{gcc_for_opt}
%install_info --info-dir=%{_infodir} %{_infodir}/fastjar.info.gz
%endif

%postun -n libgcj-4.1
%if !%{gcc_for_opt}
%install_info_delete --info-dir=%{_infodir} %{_infodir}/fastjar.info.gz
%endif
%if %{build_ada}

%post ada
%if !%{gcc_for_opt}
%install_info --info-dir=%{_infodir} %{_infodir}/gnat-style.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gnat_rm.info.gz
%install_info --info-dir=%{_infodir} --section="GNU Ada tools" --entry="* GNAT User's Guide: (gnat_ug_unx). GNAT User's Guide for Unix Platforms" %{_infodir}/gnat_ug_unx.info.gz
%endif
%endif
%if %{build_ada}

%postun ada
%if !%{gcc_for_opt}
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gnat-style.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gnat_rm.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gnat_ug_unx.info.gz
%endif
%endif

%files
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%dir %{libsubdir}/include
%if %{versionspecificlibs}
%if %{biarch}
%if %{build_primary_64bit}
%dir %{mainlibdirbi32}
%else
%dir %{mainlibdirbi64}
%endif
%endif
%endif
%if %{biarch}
%if %{build_primary_64bit}
# This link is essential for correct execution
%{_libdir}/32
/%{_lib}/32
%else
%{_libdir}/64
%endif
%endif
%{_prefix}/bin/cc%{binsuffix}
%{_prefix}/bin/gcc%{binsuffix}
%{_prefix}/bin/gccbug%{binsuffix}
%{_prefix}/bin/gcov%{binsuffix}
%{_prefix}/bin/protoize%{binsuffix}
%{_prefix}/bin/unprotoize%{binsuffix}
%{libsubdir}/collect2
%{libsubdir}/*crt*.o
%{libsubdir}/SYSCALLS.c.X
%{libsubdir}/include/README
%{libsubdir}/include/float.h
%{libsubdir}/include/iso646.h
%{libsubdir}/include/limits.h
%{libsubdir}/include/stdarg.h
%{libsubdir}/include/stdbool.h
%{libsubdir}/include/stddef.h
%{libsubdir}/include/syslimits.h
%{libsubdir}/include/unwind.h
%{libsubdir}/include/varargs.h
%ifarch ppc ppc64
%{libsubdir}/include/altivec.h
%{libsubdir}/include/ppc-asm.h
%endif
%ifarch ia64
%{libsubdir}/include/ia64intrin.h
%endif
%ifarch %arm
%{libsubdir}/include/mmintrin.h
%endif
%ifarch %ix86 x86_64
%{libsubdir}/include/mm3dnow.h
%{libsubdir}/include/mmintrin.h
%{libsubdir}/include/emmintrin.h
%{libsubdir}/include/pmmintrin.h
%{libsubdir}/include/xmmintrin.h
%{libsubdir}/include/mm_malloc.h
%endif
%{libsubdir}/libgcc.a
%{libsubdir}/libgcc_eh.a
%{libsubdir}/libgcov.a
%if %{biarch}
%if %{build_primary_64bit}
%if !%{versionspecificlibs}
%dir %{libsubdir}/32
%endif
%{libsubdir}/32/*crt*
%{libsubdir}/32/libgcc*a
%if %{versionspecificlibs}
#%{libsubdir}/32/libgcc_s*.so
%endif
%{libsubdir}/32/libgcov.a
%else
%if !%{versionspecificlibs}
%dir %{libsubdir}/64
%endif
%{libsubdir}/64/*crt*
%{libsubdir}/64/libgcc*.a
%{libsubdir}/64/libgcov.a
%endif
%endif
%ifarch ppc
%dir %{libsubdir}/64
%endif
%if %{build_nof}
%ifarch ppc
%dir %{libsubdir}/nof
%{libsubdir}/nof/*crt*
%{libsubdir}/nof/libgcc*.a
%{libsubdir}/nof/libgcov.a
%endif
%ifarch ppc64
#%{libsubdir}/32/nof
%endif
%endif
%if %{versionspecificlibs}
%{mainlibdir}/libgcc_s.so
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libgcc_s.so
%{mainlibdirbi32}/libgcc_s_32.so
%else
# 32-bit biarch systems
%{mainlibdirbi64}/libgcc_s.so
%{mainlibdirbi64}/libgcc_s_64.so
%endif
%endif
%else
%{_libdir}/libgcc_s.so
%if %{biarch}
%if %{build_primary_64bit}
%{_prefix}/lib/libgcc_s.so
%{_prefix}/lib/libgcc_s_32.so
%else
# 32-bit biarch systems
%{_prefix}/lib64/libgcc_s.so
%{_prefix}/lib64/libgcc_s_64.so
%endif
%endif
%endif
%doc %{_mandir}/man1/gcc%{binsuffix}.1.gz
%doc %{_mandir}/man1/gcov%{binsuffix}.1.gz
%if %{run_tests}
%doc testresults/*.sum
%doc testresults/*.log
%endif
%if !%{versionspecificlibs}

%files locale
%defattr(-,root,root)
%{_prefix}/share/locale/*/LC_MESSAGES/gcc.mo
%{_prefix}/share/locale/*/LC_MESSAGES/cpplib.mo
%endif

%files c++
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%{_prefix}/bin/c++%{binsuffix}
%{_prefix}/bin/g++%{binsuffix}
%doc %{_mandir}/man1/g++%{binsuffix}.1.gz
%{libsubdir}/cc1plus

%files -n libstdc++-devel-4.1 -f c++-headers
%defattr(-,root,root)
%{mainlibdir}/libstdc++.a
%{mainlibdir}/libstdc++.la
%{mainlibdir}/libstdc++.so
%{mainlibdir}/libsupc++.a
%{mainlibdir}/libsupc++.la
%if %{build_nof}
%{noflibdir}/libstdc++.a
%{noflibdir}/libstdc++.la
%{noflibdir}/libstdc++.so
%{noflibdir}/libsupc++.a
%{noflibdir}/libsupc++.la
%endif
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libstdc++.a
%{mainlibdirbi32}/libstdc++.la
%{mainlibdirbi32}/libstdc++.so
%{mainlibdirbi32}/libsupc++.a
%{mainlibdirbi32}/libsupc++.la
%else
%if !%{separate_bi64}
%{mainlibdirbi64}/libstdc++.a
%{mainlibdirbi64}/libstdc++.la
%{mainlibdirbi64}/libstdc++.so
%{mainlibdirbi64}/libsupc++.a
%{mainlibdirbi64}/libsupc++.la
%endif
%endif
%endif
%doc libstdc++-v3/docs/html
%if %{separate_bi64}

%files -n libstdc++-devel-4.1-64bit
%defattr(-,root,root)
%{mainlibdirbi64}/libstdc++.a
%{mainlibdirbi64}/libstdc++.la
%{mainlibdirbi64}/libstdc++.so
%{mainlibdirbi64}/libsupc++.a
%{mainlibdirbi64}/libsupc++.la
%endif

%files -n libgcc-4.1
%defattr(-,root,root)
%if !%{globallibs}
%{mainlibdir}/libgcc_s.so.%{libgcc_s}
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libgcc_s.so.%{libgcc_s}
%else
%if !%{separate_bi64}
%{mainlibdirbi64}/libgcc_s.so.%{libgcc_s}
%endif
%endif
%endif
%if %{build_nof}
%dir %{noflibdir}
%{noflibdir}/libgcc_s.so.%{libgcc_s}
%endif
%else
# not versionspecificlibs
/%{_lib}/libgcc_s.so.%{libgcc_s}
%if %{build_nof}
%dir /lib/nof
/lib/nof/libgcc_s.so.%{libgcc_s}
%endif
%if %{biarch}
%if %{build_primary_64bit}
/lib/libgcc_s.so.%{libgcc_s}
%else
%if !%{separate_bi64}
/lib64/libgcc_s.so.%{libgcc_s}
%endif
%endif
%endif
%endif
%if %{separate_bi64}

%files -n libgcc-4.1-64bit
%defattr(-,root,root)
%if !%{globallibs}
%{mainlibdirbi64}/libgcc_s.so.%{libgcc_s}
%else
/lib64/libgcc_s.so.%{libgcc_s}
%endif
%endif

%files -n libstdc++-4.1
%defattr(-,root,root)
%if %{globallibs}
%{_libdir}/libstdc++.so.*
%else
%{mainlibdir}/libstdc++.so.*
%endif
%if %{build_nof}
%if %{globallibs}
%{_prefix}/lib/nof/libstdc++.so.*
%else
%dir %{noflibdir}
%{noflibdir}/libstdc++.so.*
%endif
%endif
%if %{biarch}
%if %{build_primary_64bit}
%if %{globallibs}
%{_prefix}/lib/libstdc++.so.*
%else
%{mainlibdirbi32}/libstdc++.so.*
%endif
%else
%if !%{separate_bi64}
%if %{globallibs}
%{_prefix}/lib64/libstdc++.so.*
%else
%{mainlibdirbi64}/libstdc++.so.*
%endif
%endif
%endif
%endif
%if !%{versionspecificlibs}
%{_prefix}/share/locale/*/LC_MESSAGES/libstdc++.mo
%endif
%if %{separate_bi64}

%files -n libstdc++-4.1-64bit
%defattr(-,root,root)
%if %{globallibs}
%{_prefix}/lib64/libstdc++.so.*
%else
%{mainlibdirbi64}/libstdc++.so.*
%endif
%endif
%if %{build_fortran}

%files fortran
%defattr(-,root,root)
%{_prefix}/bin/gfortran%{binsuffix}
%{libsubdir}/f951
%{mainlibdir}/libgfortran.a
%{mainlibdir}/libgfortran.la
%{mainlibdir}/libgfortran.so*
%{mainlibdir}/libgfortranbegin.a
%{mainlibdir}/libgfortranbegin.la
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libgfortran.a
%{mainlibdirbi32}/libgfortran.la
%{mainlibdirbi32}/libgfortran.so*
%{mainlibdirbi32}/libgfortranbegin.a
%{mainlibdirbi32}/libgfortranbegin.la
%else
%if !%{separate_bi64}
%{mainlibdirbi64}/libgfortran.a
%{mainlibdirbi64}/libgfortran.la
%{mainlibdirbi64}/libgfortran.so*
%{mainlibdirbi64}/libgfortranbegin.a
%{mainlibdirbi64}/libgfortranbegin.la
%endif
%endif
%endif
%if %{build_nof}
%dir %{noflibdir}
%{noflibdir}/libgfortran.a
%{noflibdir}/libgfortran.la
%{noflibdir}/libgfortran.so*
%{noflibdir}/libgfortranbegin.a
%{noflibdir}/libgfortranbegin.la
%endif
%if !%{versionspecificlibs}
%doc %{_infodir}/gfortran.info*.gz
%endif
%doc %{_mandir}/man1/gfortran%{binsuffix}.1.gz
%if %{separate_bi64}

%files fortran-64bit
%defattr(-,root,root)
%{mainlibdirbi64}/libgfortran.a
%{mainlibdirbi64}/libgfortran.la
%{mainlibdirbi64}/libgfortran.so*
%{mainlibdirbi64}/libgfortranbegin.a
%{mainlibdirbi64}/libgfortranbegin.la
%endif
%endif

%files mudflap
%defattr(-,root,root)
%{_prefix}/include/mf-runtime.h
%{mainlibdir}/libmudflap.a
%{mainlibdir}/libmudflap.la
%{mainlibdir}/libmudflap.so*
%{mainlibdir}/libmudflapth.a
%{mainlibdir}/libmudflapth.la
%{mainlibdir}/libmudflapth.so*
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libmudflap.a
%{mainlibdirbi32}/libmudflap.la
%{mainlibdirbi32}/libmudflap.so*
%{mainlibdirbi32}/libmudflapth.a
%{mainlibdirbi32}/libmudflapth.la
%{mainlibdirbi32}/libmudflapth.so*
%else
%if !%{separate_bi64}
%{mainlibdirbi64}/libmudflap.a
%{mainlibdirbi64}/libmudflap.la
%{mainlibdirbi64}/libmudflap.so*
%{mainlibdirbi64}/libmudflapth.a
%{mainlibdirbi64}/libmudflapth.la
%{mainlibdirbi64}/libmudflapth.so*
%endif
%endif
%endif
%if %{build_nof}
%dir %{noflibdir}
%{noflibdir}/libmudflap.a
%{noflibdir}/libmudflap.la
%{noflibdir}/libmudflap.so*
%{noflibdir}/libmudflapth.a
%{noflibdir}/libmudflapth.la
%{noflibdir}/libmudflapth.so*
%endif
%if %{separate_bi64}

%files mudflap-64bit
%defattr(-,root,root)
%{mainlibdirbi64}/libmudflap.a
%{mainlibdirbi64}/libmudflap.la
%{mainlibdirbi64}/libmudflap.so*
%{mainlibdirbi64}/libmudflapth.a
%{mainlibdirbi64}/libmudflapth.la
%{mainlibdirbi64}/libmudflapth.so*
%endif
%if !%{versionspecificlibs}

%files info
%defattr(-,root,root)
%doc %{_infodir}/cpp.info*.gz
%doc %{_infodir}/cppinternals.info*.gz
%doc %{_infodir}/gcc.info*.gz
%doc %{_infodir}/gccint.info*.gz
%doc %{_infodir}/gccinstall.info*.gz
%endif

%files -n cpp-4.1
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%if !%{gcc_for_opt}
/lib/cpp
%endif
%{_prefix}/bin/cpp%{binsuffix}
%{libsubdir}/cc1
#%{libsubdir}/specs
%doc %{_mandir}/man1/cpp%{binsuffix}.1.gz

%files objc
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%dir %{libsubdir}/include
%{libsubdir}/cc1obj
%{libsubdir}/include/objc
%{mainlibdir}/libobjc.a
%{mainlibdir}/libobjc.la
%{mainlibdir}/libobjc.so
%if %{build_nof}
%{noflibdir}/libobjc.a
%{noflibdir}/libobjc.la
%{noflibdir}/libobjc.so
%endif
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libobjc.a
%{mainlibdirbi32}/libobjc.la
%{mainlibdirbi32}/libobjc.so
%else
%if !%{separate_bi64}
%{mainlibdirbi64}/libobjc.a
%{mainlibdirbi64}/libobjc.la
%{mainlibdirbi64}/libobjc.so
%endif
%endif
%endif
%if %{separate_bi64}

%files objc-64bit
%defattr(-,root,root)
%{mainlibdirbi64}/libobjc.a
%{mainlibdirbi64}/libobjc.la
%{mainlibdirbi64}/libobjc.so
%endif

%files -n libobjc-4.1
%defattr(-,root,root)
%{mainlibdir}/libobjc.so.*
%if %{build_nof}
%dir %{noflibdir}
%{noflibdir}/libobjc.so.*
%endif
%if %{biarch}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libobjc.so.*
%else
%if !%{separate_bi64}
%{mainlibdirbi64}/libobjc.so.*
%endif
%endif
%endif
%if %{separate_bi64}

%files -n libobjc-4.1-64bit
%defattr(-,root,root)
%{mainlibdirbi64}/libobjc.so.*
%endif
%if %{build_java}

%files java
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%{_prefix}/bin/gcj%{binsuffix}
%{_prefix}/bin/gcjh%{binsuffix}
%{_prefix}/bin/gjnih%{binsuffix}
%{_prefix}/bin/jcf-dump%{binsuffix}
%{_prefix}/bin/jv-scan%{binsuffix}
%if !%{versionspecificlibs}
%dir %{_libdir}/security
%{_libdir}/security/classpath.security
%{_libdir}/security/libgcj.security
%endif
%dir %{_libdir}/gcj-%{gcc_version}
%{_libdir}/gcj-%{gcc_version}/classmap.db
%{libsubdir}/jc1
%{libsubdir}/jvgenmain
%if !%{versionspecificlibs}
%doc %{_infodir}/gcj.info*.gz
%endif
%doc %{_mandir}/man1/gcj%{binsuffix}.1.gz
%doc %{_mandir}/man1/gcjh%{binsuffix}.1.gz
%doc %{_mandir}/man1/gjnih%{binsuffix}.1.gz
%doc %{_mandir}/man1/jcf-dump%{binsuffix}.1.gz
%doc %{_mandir}/man1/jv-scan%{binsuffix}.1.gz

%files -n libgcj-4.1
%defattr(-,root,root)
%{_prefix}/bin/gcj-dbtool%{binsuffix}
%{_prefix}/bin/gij%{binsuffix}
%{_prefix}/bin/grepjar%{binsuffix}
%{_prefix}/bin/jv-convert%{binsuffix}
%{_prefix}/bin/fastjar%{binsuffix}
%{_prefix}/bin/grmic%{binsuffix}
%{_prefix}/bin/grmiregistry%{binsuffix}
%{_prefix}/share/java/libgcj-%{gcc_version}.jar
%{mainlibdir}/libgcj.so.*
%{mainlibdir}/libgij.so.*
%{mainlibdir}/libgcjawt.so.*
%{mainlibdir}/lib-gnu-java-awt-peer-gtk.so.*
# these libs may get dlopened by their .la/.so name
%{mainlibdir}/libgcjawt.la
%{mainlibdir}/libgcjawt.so
%{mainlibdir}/lib-gnu-java-awt-peer-gtk.la
%{mainlibdir}/lib-gnu-java-awt-peer-gtk.so
%if !%{versionspecificlibs}
%{_libdir}/logging.properties
%endif
%if %{build_nof}
%if %{biarch_libjava}
%dir %{noflibdir}
%{noflibdir}/libgcj.so.*
%{noflibdir}/libgij.so.*
%{noflibdir}/libgcjawt.so.*
%{noflibdir}/lib-gnu-java-awt-peer-gtk.so.*
# these libs may get dlopened by their .la/.so name
%{noflibdir}/libgcjawt.la
%{noflibdir}/libgcjawt.so
%{noflibdir}/lib-gnu-java-awt-peer-gtk.la
%{noflibdir}/lib-gnu-java-awt-peer-gtk.so
%if %{versionspecificlibs}
%{noflibdir}/libgcj.spec
%endif
%endif
%endif
%if %{biarch}
%if %{biarch_libjava}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libgcj.so.*
%{mainlibdirbi32}/libgij.so.*
%{mainlibdirbi32}/libgcjawt.so.*
%{mainlibdirbi32}/lib-gnu-java-awt-peer-gtk.so.*
# these libs may get dlopened by their .la/.so name
%{mainlibdirbi32}/libgcjawt.la
%{mainlibdirbi32}/libgcjawt.so
%{mainlibdirbi32}/lib-gnu-java-awt-peer-gtk.la
%{mainlibdirbi32}/lib-gnu-java-awt-peer-gtk.so
%else
%{mainlibdirbi64}/libgcj.so.*
%{mainlibdirbi64}/libgij.so.*
%{mainlibdirbi64}/libgcjawt.so.*
%{mainlibdirbi64}/lib-gnu-java-awt-peer-gtk.so.*
# these libs may get dlopened by their .la/.so name
%{mainlibdirbi64}/libgcjawt.la
%{mainlibdirbi64}/libgcjawt.so
%{mainlibdirbi64}/lib-gnu-java-awt-peer-gtk.la
%{mainlibdirbi64}/lib-gnu-java-awt-peer-gtk.so
%endif
%endif
%endif
%if !%{versionspecificlibs}
%doc %{_infodir}/fastjar.info*.gz
%endif
%doc %{_mandir}/man1/gij%{binsuffix}.1.gz
%doc %{_mandir}/man1/gcj-dbtool%{binsuffix}.1.gz
%doc %{_mandir}/man1/grepjar%{binsuffix}.1.gz
%doc %{_mandir}/man1/fastjar%{binsuffix}.1.gz
%doc %{_mandir}/man1/grmic%{binsuffix}.1.gz
%doc %{_mandir}/man1/grmiregistry%{binsuffix}.1.gz
# These files conflict with the normal Java packages
#%doc %{_mandir}/man1/jv-convert.1.gz

%files -n libgcj-devel-4.1
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%dir %{libsubdir}/include
%dir %{_prefix}/include/c++
%dir %{gxxinclude}
%{_prefix}/bin/addr2name.awk%{binsuffix}
%{libsubdir}/include/jawt.h
%{libsubdir}/include/jawt_md.h
%{libsubdir}/include/jni.h
%{libsubdir}/include/jni_md.h
%{libsubdir}/include/jvmpi.h
%{gxxinclude}/gnu
%{gxxinclude}/gcj
%{gxxinclude}/java
%{gxxinclude}/javax
%{gxxinclude}/org
%{libsubdir}/include/gcj
%{mainlibdir}/libgcj.la
%{mainlibdir}/libgcj.so
%{mainlibdir}/libgcj.spec
%{mainlibdir}/libgij.la
%{mainlibdir}/libgij.so
%if %{build_nof}
%if %{biarch_libjava}
%{noflibdir}/libgcj.la
%{noflibdir}/libgcj.so
%{noflibdir}/libgij.la
%{noflibdir}/libgij.so
%endif
%endif
%if %{biarch}
%if %{biarch_libjava}
%if %{build_primary_64bit}
%{mainlibdirbi32}/libgcj.la
%{mainlibdirbi32}/libgcj.so
%{mainlibdirbi32}/libgij.la
%{mainlibdirbi32}/libgij.so
%if %{versionspecificlibs}
%{mainlibdirbi32}/libgcj.spec
%endif
%else
%{mainlibdirbi64}/libgcj.la
%{mainlibdirbi64}/libgcj.so
%{mainlibdirbi64}/libgij.la
%{mainlibdirbi64}/libgij.so
%if %{versionspecificlibs}
%{mainlibdirbi64}/libgcj.spec
%endif
%endif
%endif
%endif
%endif
%if %{build_ada}

%files ada
%defattr(-,root,root)
%dir %{_libdir}/gcc
%dir %{_libdir}/gcc/%{GCCDIST}
%dir %{libsubdir}
%{_prefix}/bin/gnat*
%{_prefix}/bin/gpr*
%{libsubdir}/adainclude
%dir %{libsubdir}/adalib
%{libsubdir}/adalib/*.ali
%{libsubdir}/adalib/*.a
%{libsubdir}/adalib/libgnarl.so
%{libsubdir}/adalib/libgnat.so
%{libsubdir}/adalib/g-trasym.o
%{libsubdir}/gnat1
%if !%{versionspecificlibs}
%doc %{_infodir}/gnat-style.info*gz
%doc %{_infodir}/gnat_rm.info*gz
%doc %{_infodir}/gnat_ugn_unw.info*gz
%endif

%files -n libada-4.1
%defattr(-,root,root)
%{_libdir}/libgnarl-*.so
%{_libdir}/libgnat-*.so
# XXX: libada is not multilib aware yet.
%if %{build_nof}
#%{noflibdir}/libgnarl-*.so
#%{noflibdir}/libgnat-*.so
%endif
%if %{biarch}
%if %{build_primary_64bit}
#%{_prefix}/lib/libgnarl-*.so
#%{_prefix}/lib/libgnat-*.so
%else
#%{_prefix}/lib64/libgnarl-*.so
#%{_prefix}/lib64/libgnat-*.so
%endif
%endif
%endif

%changelog -n gcc-4.1
* Thu Jul 06 2006 - matz@suse.de
- Correctly emit debug info for arguments.  [#189571]
* Fri Jun 16 2006 - rguenther@suse.de
- Disable hack that made -mno-tls-direct-seg-refs the default
  on x86_64.  [#185782]
* Fri Jun 09 2006 - matz@suse.de
- Add patch for PR27761, miscompilation on ia64.  [#178330]
- Add patch for PR27661, ICE on s390x.  [#171129 for SLES9]
- Add patch for PR27743, miscompilation of double shifts.
- Add patch for PR27603, miscompilation in VRP, i.e. with -O2.
- Add patch for PR26729, miscompilation with bit masks.
* Wed May 03 2006 - matz@suse.de
- Add patch for PR27409, an ICE.  [#170939]
* Wed May 03 2006 - rguenther@suse.de
- Add patch for PR27364, VRP miscompiles multiplication with overflow,
  miscompilation of binutils.
- Add patch for PR14261 for ia64, s390 and s390x, ICE for code resembling to
  yacc output.  [#171728]
* Fri Apr 28 2006 - rguenther@suse.de
- Add patch for PR26399, -fprofile-generate/use checksum
  mismatches.  [#159466]
* Sat Apr 22 2006 - rguenther@suse.de
- Add patch to fix fallout from patch for PR27095, fix PR27260.
* Thu Apr 20 2006 - rguenther@suse.de
- Add patch to fix ppc long-double varargs ABI issue.  [#167932]
* Wed Apr 19 2006 - rguenther@suse.de
- Add patch to reorder indexed load/store operands on rs6000.  [#161673]
* Tue Apr 18 2006 - rguenther@suse.de
- Add patch for PR25917, wrong assembly generated on ia64
  for certain bitops and extensions.
- Add patch for PR26777, std::pubseekoff throwing away buffered
  data on error.
- Add patch for PR26996, SCEV analysis ICEing on vector types.
- Add patch for PR27006, wrong assembly genrated on ppc/ppc64
  for altivec constant loading.
- Add patch for PR27095, memset and strcmp evaluating length argument
  twice.
- Add patch for PR27134, ICEing on (int)floor() and other rounding
  functions with -ffast-math.
- Add patch for PR27162, using == instead of the binary predicate
  specified for std::search_n.
* Sat Apr 08 2006 - rguenther@suse.de
- Update patch for PR26919 to also collect garbage.
* Fri Apr 07 2006 - rguenther@suse.de
- Add patch for PR26919.
- Merge up to rev 112748 for gfortran changes on the branch.
  [#162890, #163146]
* Mon Apr 03 2006 - rguenther@suse.de
- Add patch for PR26763.
* Thu Mar 30 2006 - rguenther@suse.de
- Fix #153386 in a different way.
- Add patch for PR26042.  [#148884]
* Mon Mar 27 2006 - rguenther@suse.de
- Really fix #153386.
* Thu Mar 23 2006 - rguenther@suse.de
- Update patch for PR26565.
- Add patch for PR25737.
- Add patch for OpenOffice problems.  [#153386]
- Add patch for PR26826.  [#160095]
- Enable Cairo support in libjava.
* Wed Mar 15 2006 - rguenther@suse.de
- Add patch to update to r112077.
  [#19543, #26489, #26557, #26672, #18859, #26004, #26524, #26587,
  [#26345], #26453, #26291, #25885, #26054, #26041, #26064, #26107,
  [#26393], #20938, #24519, #25395, #25054, #25089, #24557, #23092,
  [#25045], #25075, #21303, #26499, #26554, #21303, #24903, #26136,
  [#26464], #26423, #26532, #26132, #26526, #25713, #24461, #26103]
- Patches for PR26587, PR26526 no longer necessary.
- Update patch for PR26565.
- Add patch for PR26643.
- Move libgcjawt.(so|la) and lib-gnu-java-awt-peer-gtk.(so|la) to the
  gcc-java package because these are dlopened by the runtime. [#157655]
* Tue Mar 07 2006 - rguenther@suse.de
- Add patch for PR26587, miscompilation due to wrong PTA info.
- Add patch for PR26565, unaligned accesses on strict alignment targets.
- Add patch for PR26526, missing 64bit export for __copy_streambufs.
* Tue Feb 28 2006 - rguenther@suse.de
- Update to 4.1.0 release.
- Patch for PR25603 no longer necessary.
- Add patch for PR24879.
- Add fortran WHERE optimizations.
* Thu Feb 23 2006 - rguenther@suse.de
- Update to SVN head.
- Patch for PR26350 no longer necessary.
- Add patch for PR25603.  [#152811]
- Add patch for NVL152859.  [#152859]
* Sat Feb 18 2006 - rguenther@suse.de
- Update to SVN head.  [#26334]
- Patch for PR26209 no longer necessary.
- Add patch for PR26350.
* Tue Feb 14 2006 - rguenther@suse.de
- Update to SVN head.  [#150421]
- Add patches for latent VRP and fold bugs.
- Enable long-double-128 by default on s390, s390x, ppc and ppc64.
- Add patch for PR26209.
* Sun Feb 12 2006 - matz@suse.de
- Don't add /lib/*/libc.so to the cross backends.
* Fri Feb 10 2006 - rguenther@suse.de
- Update to SVN head.  [#25251][#26180]
* Wed Feb 08 2006 - matz@suse.de
- Make the cross-ppc-icecream-backend accept -m64.
* Tue Feb 07 2006 - rguenther@suse.de
- Update to SVN head.
- S390 long double patch now upstream.
- Drop in long double patchset from FC.
- Disable all Ada workarounds.
* Wed Feb 01 2006 - rguenther@suse.de
- Update to SVN head.
- Re-diff ada patch for ppc.
- Add another minor libstdc++ improvement from Paolo.
- Re-enable --with-tune=z9-109 --with-arch=z900 change on s390(x).
- Update long double patch for s390.
* Mon Jan 30 2006 - rguenther@suse.de
- Update to SVN head.
- Add ppc32, s390(x) 128bit long-double support.
- Add missing intrinsics to emm headers.
- Add candidate patch for ada build problem on s390x.
- Revert --with-tune=z9-109 --with-arch=z900 change on s390(x).
- Patch for PR25324 no longer necessary.
* Fri Jan 27 2006 - rguenther@suse.de
- Update to SVN head as of Mon Jan 23.
- Add patches for PR22275, PR25626 and PR25324.
- Patches for PR23948 and PR25535 no longer necessary.
- Exchange patches that fix atomic builtins for a better one.
- Add patch to fix unexpected EOF in fix-header.
- Update patch(es) for generic CPU model.
- Add gfortran matmul patch.
- Use --with-tune=z9-109 --with-arch=z900 for s390(x).
- Disable ada for s390x.
- Don't build fortran for crosses.  Don't depend on gmp either.
- Re-add dejagnu and expect build dependencies if running the testsuite.
- Require gcc-ada build dependency only if building ada.
* Thu Jan 26 2006 - sndirsch@suse.de
- no longer use sysroot for cross-avr to fix linker error
  "this linker was not configured to use sysroots" (Bug #145783)
* Thu Jan 26 2006 - ro@suse.de
- re-added glibc-devel-32bit to gcc.spec
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Sat Jan 14 2006 - rguenther@suse.de
- Add gmp-devel to build dependencies.
* Thu Jan 12 2006 - rguenther@suse.de
- Fix large-model patch.
- Enable large-model, blended CPU model and the multilib searchdir
  patches for STABLE, too.
* Mon Jan 09 2006 - rguenther@suse.de
- Update to current SVN head.
- Patches for PR22533 and PR25130 no longer necessary.
* Sun Jan 08 2006 - sndirsch@suse.de
- enabled build of g++ for cross-avr; crash-bobby (www.qfix.de)
  needs a C++ compiler
* Fri Jan 06 2006 - aj@suse.de
- Update generic model patch.
* Tue Jan 03 2006 - rguenther@suse.de
- Update to current SVN head.
- Workaround for PR25023 should be no longer necessary.
- Add patch for PR25130.
- Add patches from RH SRPM, java fixes, ia64 ssp support,
  s390 and ppc64 atomic fixes.
* Fri Dec 30 2005 - aj@suse.de
- Do not package static java libraries since linking statically
  with them will not really work.
- Update to current SVN head.
* Thu Dec 22 2005 - rguenther@suse.de
- Add patch for generic CPU model (x86_64 only) for BETA.
* Wed Dec 21 2005 - rguenther@suse.de
- Enable checking for BETA.
- Enable large-model patch for BETA.
- Enable patch for PR20425 for BETA.
* Wed Dec 21 2005 - aj@suse.de
- Update to current SVN head.
* Mon Dec 19 2005 - rguenther@suse.de
- Add patch for PR25310.
- Remove libssp again, glibc has the required support now.
- Remove SPARCles from the spec file.
- Downgrade checking to release checking in STABLE.
- Fix all unpackaged symlinks.
* Thu Dec 15 2005 - rguenther@suse.de
- Disable patch for PR20425 for stable.
- Fix libssp location for ppc.
* Mon Dec 12 2005 - rguenther@suse.de
- Fix 64bit libssp install on ppc.
- Update patch for PR20425.
* Sun Dec 11 2005 - aj@suse.de
- Update to current SVN head.
- Enable libssp.
* Fri Dec 09 2005 - rguenther@suse.de
- Update to current SVN head.
- C++ strict aliasing warnings now upstream.
- Patch for PR24908 no longer necessary.
- Add patches for PR25180, PR25311 and PR20425.
- Enable Ada workaround for hppa, too.
- Enable --enable-secureplt for ppc and ppc64 targets.
* Wed Nov 30 2005 - rguenther@suse.de
- Update to current SVN head.
- Add patches for PR24823 and PR24908.
* Thu Nov 24 2005 - rguenther@suse.de
- Add patch for PR24982.
- Add workaround for PR25023.
* Wed Nov 23 2005 - rguenther@suse.de
- Update to current SVN head.
- Add different fix for PR22533.
- Disable Ada workarounds for s390 and s390x.
- Add patch for PR24626.
- Patches for PR20928, PR24172 and PR23717 no longer necessary.
- Ada EH on s390 fixed upstream.
- Add patch to disable aliasing-warnings in std::string.
* Fri Nov 18 2005 - schwab@suse.de
- Fix Ada library links.
* Wed Nov 16 2005 - rguenther@suse.de
- Update to current SVN head.
- Patch for PR22509 no longer necessary.
- No more reversion of AJs patch to libgfortran.
- Disable inst-prefix-dir.patch.
- Re-enable Ada workarounds, fix Ada EH on s390.
* Thu Nov 10 2005 - rguenther@suse.de
- Update to current SVN head.
- Check if we accidentially end up with make -j0 and fix it.
- Update patch for PR23948.
- Patches for PR24627 and PR24230 no longer necessary.
- Revert patch from AJ to libgfortran.h.
* Wed Nov 02 2005 - rguenther@suse.de
- Update to current SVN head.
- Patches for PR24225, PR24351 no longer necessary.
- Add patches for PR24230, PR24627, PR22509.
- Disable some of the ada workarounds.
- Disable java for arm.
* Tue Nov 01 2005 - rguenther@suse.de
- Exchange patch for PR24351.
* Thu Oct 27 2005 - rguenther@suse.de
- Add patch for PR24351.
- Use libstdc++ allocator "new" instead of default "mt"
  for compatibility and possibly LSB3.0 conformance.
* Mon Oct 24 2005 - rguenther@suse.de
- Update to current CVS head.
- Add patch for PR24225.
* Wed Oct 19 2005 - rguenther@suse.de
- Update to current CVS head.
- Disable strict-aliasing patch.
- Patch for PR24255 is no longer needed.
- Fix RPM_OPT_FLAGS for cross-avr to not include
  -march/cpu/tune stuff.
* Fri Oct 14 2005 - rguenther@suse.de
- Add patch for PR24172.
- Add patch for PR24255.
* Wed Oct 12 2005 - rguenther@suse.de
- Update to current CVS head.
- Add patch for PR23948.
- Update strict-aliasing patch.
- Apply patch6 to ppc/ppc64, too.
* Mon Oct 10 2005 - rguenther@suse.de
- Add patch to warn about papering over strict-aliasing bugs.
* Sat Oct 08 2005 - aj@suse.de
- Update to current CVS head.
* Sat Oct 01 2005 - schwab@suse.de
- Update to current CVS head.
- Add workaround for PR22533.
* Thu Sep 22 2005 - schwab@suse.de
- Build Ada with -O0 and reenable.
* Tue Sep 20 2005 - aj@suse.de
- Update to current CVS head.
- Add patch for PR22438.
- Disable Ada on ppc, s390, s390x for now.
- Fix .la files.
* Mon Sep 19 2005 - aj@suse.de
- Update to current CVS head.
* Fri Sep 16 2005 - aj@suse.de
- Update to CVS Head.
* Fri Sep 09 2005 - schwab@suse.de
- Update to current CVS.
* Tue Sep 06 2005 - schwab@suse.de
- Disable testsuite for now.
* Sun Sep 04 2005 - schwab@suse.de
- Avoid strict aliasing warning.
* Sat Sep 03 2005 - schwab@suse.de
- Update to CVS HEAD.
* Fri Aug 26 2005 - aj@suse.de
- Update to current CVS to fix GCC bug #23546.
* Thu Aug 25 2005 - matz@suse.de
- Update to current CVS.
- Enable java on hppa.
* Tue Aug 23 2005 - meissner@suse.de
- Applied bugfix for fortify checking from Jakub Jelinek.
  (gcc PR middle-end/23484)
* Thu Aug 18 2005 - matz@suse.de
- Update to current CVS.
* Wed Aug 17 2005 - matz@suse.de
- Enable Ada on hppa.
* Wed Aug 17 2005 - jw@suse.de
- cross-avr-gcc: Enabled avr2 support in micro-cross.spec.in
  fixes #105206
- micro-cross.spec.in more robust against gcc.spec changes.
* Thu Aug 11 2005 - aj@suse.de
- Fix PR23326 [#99249 - kopete miscompilation].
- Update to current CVS for:
  * Fix PR23312 [ada ICEs]
  * Fix PR23266 [C++ ICE]
* Thu Aug 11 2005 - aj@suse.de
- Update to current CVS.
- Add gcc-locale package again [#103757].
- Fix gcc-mainline 64bit lib names.
* Sun Aug 07 2005 - matz@suse.de
- Update to current CVS.
- Fixes PR23192, which results in miscompilation of libpcap [#102460].
- Don't build nof libs on pcc.
* Sat Aug 06 2005 - schwab@suse.de
- Also fix cross-avr specfile.
* Fri Aug 05 2005 - schwab@suse.de
- Fix cross specfiles.
* Fri Aug 05 2005 - matz@suse.de
- Package nof dir on ppc again.
- Put 64bit libs into separate rpms on ppc.
- Rename gnat and gnat-runtime to gcc-ada resp. libada.
* Fri Aug 05 2005 - matz@suse.de
- Update to current CVS.
- Made libgcj (and friends) not biarch.
- Added libgcjawt for OpenOffice.
* Wed Jul 27 2005 - matz@suse.de
- Update to current CVS.
* Wed Jul 20 2005 - matz@suse.de
- Update to current CVS.
* Thu Jul 14 2005 - matz@suse.de
- Update to current CVS.
* Wed Jul 13 2005 - schwab@suse.de
- Parallel build fix.
- Properly detect ppc64 kernel.
* Fri Jul 01 2005 - aj@suse.de
- Update to current CVS.
* Fri Jun 24 2005 - matz@suse.de
- Fix partly empty c++config.h also for ppc.
- Fix libstdc++-devel filelist.
* Thu Jun 23 2005 - matz@suse.de
- Fix use of wrong macro, leading to partly empty c++config.h.
* Tue Jun 21 2005 - matz@suse.de
- Update to current CVS.
- Add fix for PR21721 (ia64 p0 problem).
- Add fix for PR22028.
* Mon Jun 13 2005 - matz@suse.de
- Update to current CVS.
- Pull fix for PR21171 from mainline (should fix grub, #84600).
- Add fix for PR21985 (also a grub problem).
* Thu Jun 09 2005 - schwab@suse.de
- Update to current CVS.
- Fix broken unwind info in profiling code.
* Fri Jun 03 2005 - matz@suse.de
- Update to current CVS.
- Workaround for PR21041.
* Sun May 29 2005 - aj@suse.de
- Update to current CVS.
- Package pre_checkin.sh so that Robert can use our package.
* Thu May 26 2005 - schwab@suse.de
- Fix fortify patch.
* Thu May 26 2005 - aj@suse.de
- Update to current CVS.
* Sun May 22 2005 - aj@suse.de
- Update to current CVS.
- Fix visibility hidden problems PR C++/19664 and
  PR middle-end/20218.
* Sat May 21 2005 - aj@suse.de
- Update to current CVS.
* Thu May 19 2005 - schwab@suse.de
- Update to current CVS, fixes glibc miscompilation.
* Wed May 18 2005 - aj@suse.de
- Update to current CVS - should fix ia64
  ICEs.
* Wed May 18 2005 - aj@suse.de
- Update to current CVS.
* Mon May 16 2005 - aj@suse.de
- Update to current CVS.
- Fix PowerPC gcc-mainline package.
* Sun May 15 2005 - aj@suse.de
- Update to current CVS.
- Fix warnings about uninitialized variables.
* Fri May 13 2005 - matz@suse.de
- Fix cross-avr-gcc (uses now target=avr, not avr-elf).
* Thu May 12 2005 - matz@suse.de
- Add gjnih to gcc-java.
* Thu May 12 2005 - matz@suse.de
- Update to current CVS.
- Fix filelists (libgfortran.so and libmudflapth.so).
- Add cross-avr-gcc from jw@suse.de.
* Sun May 08 2005 - matz@suse.de
- Add cross-alpha-icecream-backend.
* Wed May 04 2005 - matz@suse.de
- Update to current CVS.
* Wed May 04 2005 - schwab@suse.de
- Update to current CVS.
* Mon Apr 25 2005 - matz@suse.de
- Fix endless loop in postreload on ia64.
* Sun Apr 24 2005 - aj@suse.de
- Update to current CVS.
- Fix pre_checkin for gcc-mainline.
* Sat Apr 23 2005 - aj@suse.de
- Update to current CVS.
- Fix one PRE bug.
* Sat Apr 23 2005 - schwab@suse.de
- Provide/obsolete gcc-locale.
* Sat Apr 23 2005 - matz@suse.de
- Fix ulimit call to use kbyte not mbyte.
* Fri Apr 22 2005 - matz@suse.de
- Update to current CVS, which is a prerelease of 4.0.1.
* Sat Apr 16 2005 - meissner@suse.de
- Added RH fortify extensions.
* Fri Apr 15 2005 - matz@suse.de
- Update to current CVS.
- Fix PR20963: ICE compiling dosbox (preliminary patch).
* Wed Apr 13 2005 - ro@suse.de
- fix last patch to apply
* Tue Apr 12 2005 - schwab@suse.de
- Fix GCC PR20924: Wrong floating point flags for inline division.
* Tue Apr 12 2005 - matz@suse.de
- Testpatch for GCC PR20973: miscompile of khtml.
* Mon Apr 11 2005 - aj@suse.de
- Fix GCC PR20928: ICE compiling clisp.
- Fix GCC PR20929: ICE compiling mozilla.
* Sun Apr 10 2005 - aj@suse.de
- Update to current CVS.
- Fix GCC PR20917: ICE compiling glibc on s390.
- Fix GCC PR20126: Miscompilation of python.
* Sat Apr 09 2005 - aj@suse.de
- Update to current CVS.
* Fri Apr 08 2005 - schwab@suse.de
- Build cross compiler backends for icecream.
* Fri Apr 08 2005 - aj@suse.de
- Update to current CVS.
* Thu Apr 07 2005 - aj@suse.de
- Update to current CVS.
* Thu Apr 07 2005 - meissner@suse.de
- Add a patch for PR 20739 (ncurses bugfix)
* Wed Apr 06 2005 - aj@suse.de
- Update to current CVS.
- Require gettext packages for build.
* Tue Apr 05 2005 - aj@suse.de
- Update to current CVS.
* Fri Apr 01 2005 - aj@suse.de
- Add fixes for Arm from Ulrich Hecht.
* Fri Apr 01 2005 - aj@suse.de
- Update to current CVS.
- Fix GCC PR20635.
* Wed Mar 30 2005 - aj@suse.de
- Update to current CVS.
* Mon Mar 28 2005 - aj@suse.de
- Update to current CVS.
- build multiarch on PPC.
- Add one fix for GCC PR19345.
* Fri Mar 25 2005 - schwab@suse.de
- Update to current CVS.
* Sun Mar 20 2005 - aj@suse.de
- Update to current CVS.
* Thu Mar 17 2005 - aj@suse.de
- Update to current CVS.
* Sat Mar 12 2005 - aj@suse.de
- Update to current CVS.
* Thu Mar 10 2005 - aj@suse.de
- Update to current CVS.
* Mon Mar 07 2005 - aj@suse.de
- Update to current CVS.
* Fri Mar 04 2005 - schwab@suse.de
- Update to current CVS.
* Mon Feb 28 2005 - aj@suse.de
- Update to current CVS.
* Sat Feb 26 2005 - aj@suse.de
- Update to current CVS.
* Wed Feb 23 2005 - aj@suse.de
- Update to current CVS.
* Sun Feb 20 2005 - aj@suse.de
- Update to current CVS.
- Fix PR20017.
* Fri Feb 18 2005 - aj@suse.de
- Update to current CVS.
* Thu Feb 17 2005 - schwab@suse.de
- Add timeout to ACATS test script.
* Thu Feb 17 2005 - aj@suse.de
- Update to current CVS.
* Tue Feb 15 2005 - schwab@suse.de
- Update to current CVS.
- Apply ada-nonopt.patch also on ppc.
* Mon Feb 14 2005 - matz@suse.de
- Don't use icecream, strip senseless warning options from
  RPM_OPT_FLAGS.
* Fri Feb 11 2005 - schwab@suse.de
- Update to current CVS.
* Wed Feb 09 2005 - aj@suse.de
- Update to current CVS.
* Tue Feb 08 2005 - aj@suse.de
- Update to current CVS.
* Thu Feb 03 2005 - aj@suse.de
- Update to current CVS.
* Wed Feb 02 2005 - aj@suse.de
- Update to current CVS.
* Sun Jan 30 2005 - aj@suse.de
- Update to current CVS.
* Fri Jan 28 2005 - aj@suse.de
- Update to current CVS.
* Wed Jan 26 2005 - aj@suse.de
- Update to current CVS.
* Tue Jan 25 2005 - meissner@suse.de
- Added sentinel-c++.diff to avoid faulty sentinel
  warnings due to C++ NULL being __null.
* Mon Jan 24 2005 - aj@suse.de
- Update to current CVS.
* Thu Jan 20 2005 - aj@suse.de
- Update to current CVS.
* Wed Jan 19 2005 - aj@suse.de
- Install C++ headers into /usr/include/c++/<version>.
- Fix c++config.h for multilib systems.
- Remove old obsoletes/provides for gjava, gpp, gccinfo, gobjc,
  minigcc and gnat-3.13p-runtime.
- Update to current CVS.
* Sun Jan 16 2005 - aj@suse.de
- Enable ada on s390x.
- Update to current CVS.
* Fri Jan 14 2005 - aj@suse.de
- Update to current CVS.
* Wed Jan 12 2005 - aj@suse.de
- Update to current CVS.
- Enable ada on s390.
* Tue Jan 11 2005 - aj@suse.de
- Update to current CVS.
* Mon Jan 10 2005 - aj@suse.de
- Update to current CVS.
- Disable testsuite run for now.
* Sun Jan 09 2005 - aj@suse.de
- Update to current CVS.
- Always run testsuite for gcc-mainline.
* Sat Jan 08 2005 - aj@suse.de
- Update to current CVS.
* Mon Jan 03 2005 - aj@suse.de
- Update to current CVS.
- Remove obsolete patches.
* Sun Jan 02 2005 - schwab@suse.de
- Fix names of installed Ada programs.
- Update tree-sra patch.
* Sun Jan 02 2005 - aj@suse.de
- Update to current CVS.
* Fri Dec 31 2004 - aj@suse.de
- Update to current CVS.
- Fix gcc-mainline build.
* Mon Dec 27 2004 - aj@suse.de
- Update to current CVS.
* Thu Dec 23 2004 - aj@suse.de
- Update to current CVS.
* Fri Dec 17 2004 - aj@suse.de
- Update to current CVS.
* Wed Dec 15 2004 - aj@suse.de
- Update to current CVS.
* Tue Dec 14 2004 - schwab@suse.de
- Update to current CVS.
* Mon Dec 13 2004 - aj@suse.de
- Update to current CVS.
* Fri Dec 10 2004 - schwab@suse.de
- Fix requires for mainline build.
* Thu Dec 09 2004 - aj@suse.de
- Update to current CVS.
- Fix mainline build.
* Wed Dec 08 2004 - aj@suse.de
- Update to current CVS.
* Sat Dec 04 2004 - schwab@suse.de
- Update to current CVS.
* Tue Nov 30 2004 - aj@suse.de
- Update to current CVS.
* Sun Nov 28 2004 - schwab@suse.de
- Update to current CVS.
- Enable Ada on ppc.
* Tue Nov 23 2004 - schwab@suse.de
- Add proposed fix for PR17746.
- Work around PR17356.
- Enable Ada on ia64.
* Mon Nov 22 2004 - aj@suse.de
- Update to current CVS.
* Thu Nov 18 2004 - schwab@suse.de
- Update to current CVS.
* Sun Nov 14 2004 - schwab@suse.de
- Update to current CVS.
- Use libunwind on ia64.
* Mon Nov 08 2004 - schwab@suse.de
- Update to current CVS.
- Disable broken patch.
* Sat Nov 06 2004 - schwab@suse.de
- Update to current CVS.
* Mon Nov 01 2004 - schwab@suse.de
- Update to current CVS.
* Wed Oct 27 2004 - aj@suse.de
- update to current CVS
- add some bugfixes.
* Mon Oct 25 2004 - aj@suse.de
- Enable Ada for x86 and x86-64 architectures.
- Rename gnat to gcc-ada and gnat-runtime to libada.
- Update to current CVS.
* Fri Oct 22 2004 - aj@suse.de
- Update to current CVS.
* Mon Oct 18 2004 - aj@suse.de
- Update to current CVS.
* Sun Oct 17 2004 - aj@suse.de
- Update to current CVS.
* Wed Oct 13 2004 - aj@suse.de
- Update to current CVS.
- Fix #17906.
* Tue Oct 12 2004 - aj@suse.de
- Update to current CVS.
- Fix pr17520.
* Sun Oct 10 2004 - aj@suse.de
- Update to current CVS.
* Fri Oct 08 2004 - aj@suse.de
- Update to current CVS.
* Fri Oct 01 2004 - aj@suse.de
- Update to current CVS.
- Remove now unneeded patch.
* Wed Sep 29 2004 - aj@suse.de
- Update to current CVS.
* Fri Sep 24 2004 - aj@suse.de
- Remove obsolete patch for head +1.
* Fri Sep 24 2004 - schwab@suse.de
- Update to current CVS.
* Mon Sep 20 2004 - aj@suse.de
- Update to current CVS.
* Sat Sep 18 2004 - schwab@suse.de
- Remove extra header.
* Sat Sep 18 2004 - aj@suse.de
- Update to current CVS.
* Fri Sep 17 2004 - aj@suse.de
- Update to current CVS.
* Thu Sep 16 2004 - aj@suse.de
- Update to current CVS.
* Wed Sep 15 2004 - aj@suse.de
- Update to current CVS.
* Tue Sep 14 2004 - aj@suse.de
- Update to current CVS.
- Fix spec file for PPC.
- Add patch to fix some aliasing issues.
* Mon Sep 13 2004 - aj@suse.de
- GCC 3.5 is now GCC 4.0.
- Update to current CVS.
- Fix package list.
* Fri Sep 10 2004 - aj@suse.de
- Do no pack libgcc_s.so.1 twice.
* Thu Sep 09 2004 - aj@suse.de
- Update to current CVS.
- Adjust spec file for changes.
* Thu Sep 02 2004 - aj@suse.de
- Fix for powerpc.
- Update to current CVS.
* Fri Aug 27 2004 - aj@suse.de
- Use DESTDIR again after setting LD_LIBRARY_PATH.
* Fri Aug 27 2004 - aj@suse.de
- Update to current 3.5 CVS.
- Do not use DESTDIR/RPM_BUILD_ROOT since libtool will not
  install java correctly with it.
* Fri Aug 20 2004 - aj@suse.de
- Fix RPM_OPT_FLAGS.
- Update to current 3.5 CVS.
* Thu Aug 19 2004 - aj@suse.de
- Update to current 3.5 CVS.
* Mon Aug 09 2004 - aj@suse.de
- Update to current 3.5 CVS.
* Mon Jul 19 2004 - aj@suse.de
- Update to current 3.5 CVS.
- Fix /usr install.
* Wed Jun 16 2004 - aj@suse.de
- Update to current 3.5 CVS.
- Install into /usr.
* Thu Jun 10 2004 - aj@suse.de
- Fix build on PPC.
- Update to current 3.5 CVS.
* Wed Jun 09 2004 - aj@suse.de
- Update to current 3.5 CVS.
* Fri Jun 04 2004 - aj@suse.de
- Update to current 3.5 CVS.
- Fix spec file for x86-64 and hppa.
* Thu Jun 03 2004 - aj@suse.de
- Fix spec file.
- Update to current 3.5 CVS.
* Wed Jun 02 2004 - aj@suse.de
- Update to current 3.5 CVS, rework spec file.
* Thu May 27 2004 - aj@suse.de
- Update to GCC 3.5 CVS.
* Wed Apr 28 2004 - aj@suse.de
- Update to current CVS.
* Tue Apr 20 2004 - aj@suse.de
- Avoid warnings.
- Update to current 3.4 CVS.
* Fri Apr 09 2004 - aj@suse.de
- Update to current 3.4 CVS.
* Sat Mar 13 2004 - aj@suse.de
- Fix spec file.
- Update to current 3.4 CVS.
* Tue Mar 09 2004 - aj@suse.de
- Update to current 3.4 CVS.
* Tue Mar 02 2004 - aj@suse.de
- Update to current 3.4 CVS.
* Fri Feb 27 2004 - aj@suse.de
- Update to current 3.4 CVS.
* Wed Feb 18 2004 - aj@suse.de
- Update to current 3.4 CVS.
* Mon Feb 09 2004 - aj@suse.de
- Update to current 3.4 CVS.
* Mon Feb 02 2004 - aj@suse.de
- Update to current CVS.
* Mon Jan 26 2004 - aj@suse.de
- Update to current CVS.
* Fri Jan 23 2004 - aj@suse.de
- Update to current CVS.
* Thu Jan 22 2004 - aj@suse.de
- Update to current CVS.
* Mon Jan 19 2004 - aj@suse.de
- Update to current CVS.
* Fri Jan 16 2004 - aj@suse.de
- Update to current CVS.
* Wed Jan 14 2004 - aj@suse.de
- Update to current CVS.
- Fix spec file.
* Tue Jan 13 2004 - aj@suse.de
- Fix package list.
* Tue Jan 13 2004 - aj@suse.de
- Disable Ada on AMD64.
* Tue Jan 13 2004 - aj@suse.de
- Update to current CVS.
* Mon Jan 12 2004 - aj@suse.de
- Update to current CVS.
* Wed Jan 07 2004 - aj@suse.de
- Update to current CVS.
* Tue Dec 16 2003 - aj@suse.de
- Update to current CVS.
- change config-dist.sh to check-build.sh.
- minimal-toc is not needed anymore on ppc64.
- Fix PPC nof file list.
* Wed Dec 10 2003 - aj@suse.de
- Update to current CVS.
* Thu Dec 04 2003 - aj@suse.de
- Update to current CVS.
- Fix package list.
* Wed Dec 03 2003 - aj@suse.de
- Update to current CVS.
* Sun Nov 30 2003 - aj@suse.de
- Update to current CVS.
* Fri Nov 28 2003 - aj@suse.de
- Update to current CVS.
* Wed Oct 29 2003 - aj@suse.de
- Fix package list for i386.
* Wed Oct 29 2003 - aj@suse.de
- New package.
